// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _BadCategorizer_h
#define _BadCategorizer_h 1

#include <Categorizer.h>
#include <DisplayPref.h>

const MString BadCatDscr = "Bad Categorizer";

class BadCategorizer : public Categorizer {
   NO_DEFAULT_OPS(BadCategorizer);

   // Member Data
   static Bool instantiated;
public:
   BadCategorizer();
   virtual ~BadCategorizer() {}
   virtual int num_categories() const;
   virtual AugCategory categorize(const InstanceRC&) const;
   virtual void display_struct(MLCOStream& stream = Mcout,
			       const DisplayPref& dp = defaultDisplayPref)
      const;
   virtual Categorizer* clone() const;

   // Returns the class id
   virtual int class_id() const { return CLASS_BAD_CATEGORIZER; };
   virtual void set_used_attr(BoolArray& usedAttr) const;
   virtual void project(const BoolArray& mask);
   virtual Bool operator==(const Categorizer&) const;

   // get_schema should abort for this class
   virtual SchemaRC get_schema() const;

   static Bool is_bad_categorizer(const Categorizer&);
};

extern BadCategorizer badCategorizer;
#endif
