// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _BinningRealDiscretizor_h
#define _BinningRealDiscretizor_h 1

#include <RealDiscretizor.h>

class BinningRealDiscretizor : public RealDiscretizor{
   NO_DEFAULT_OPS(BinningRealDiscretizor);

   // Member data
   int  numBins;
protected:
   // Protected methods
   void build_thresholds(const InstanceList& sourceInstList);
public:
   BinningRealDiscretizor(int attrNum,
			  const SchemaRC& schema, int binSize);
   BinningRealDiscretizor(const BinningRealDiscretizor&, CtorDummy);
   virtual Bool operator==(const RealDiscretizor& rhs) const;
   int class_id() const{ return CLASSID_BINNINGDISC;}
   RealDiscretizor* clone() const;
};

PtrArray<RealDiscretizor*>*
create_binning_discretizors(LogOptions& logOptions,
			    const InstanceList& instList,
			    const Array<int>& binCounts);

PtrArray<RealDiscretizor*>*
create_binning_discretizors(LogOptions& logOptions,
			    const InstanceList& instList,
			    int binCount);
#endif
