// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _BoolArray_h
#define _BoolArray_h 1

#include <Array.h>

class BoolArray : public Array<Bool> {
   NO_COPY_CTOR(BoolArray);
public:
   BoolArray(const BoolArray& source, CtorDummy);
   BoolArray(const Array<int>& source, Bool supportNegative = FALSE);
   BoolArray(int baseStart, int size);
   BoolArray(int size);
   BoolArray(int baseStart, int size, const Bool& initialValue);
   ~BoolArray() {}

   void display(MLCOStream& stream = Mcout) const;
   MString get_true_indexes() const
           { return Array<Bool>::get_element_indexes(TRUE); };
   int num_true() const
           { return Array<Bool>::num_element(TRUE); };
   int num_false() const
           { return Array<Bool>::num_element(FALSE); };
};

DECLARE_DISPLAY(BoolArray)

#if defined(GNU)
static Bool operator==(const BoolArray& lhs, const BoolArray& rhs)
{ return (const Array<Bool>&)lhs==(const Array<Bool>&)rhs;}

static Bool operator!=(const BoolArray& lhs, const BoolArray& rhs)
{ return (const Array<Bool>&)lhs!=(const Array<Bool>&)rhs;}
#endif

#endif
