// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _C45APInducer_h
#define _C45APInducer_h 1

#include <SearchInducer.h>
#include <C45APState.h>
#include <C45Inducer.h>

class C45APInducer : public SearchInducer {
   NO_DEFAULT_OPS(C45APInducer);
public:
   C45APInducer(const MString& description) :
      SearchInducer(description, new C45Inducer("automatic " + description))
      {globalInfo = create_global_info(); }

   virtual int class_id() const { return C45AP_INDUCER; }
   virtual void set_user_options(const MString& prefix);
   
   virtual PerfEstInfo *create_global_info() const { return new C45APInfo; }
   virtual Array<int> *create_initial_info(InstanceList*) {
      return C45APInfo::init_flags(); }      
   virtual PerfEstState *create_initial_state(Array<int> *&initialInfo,
					     const PerfEstInfo& gI) const
      {return new C45APState(initialInfo, gI); }
};

#endif
