// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _C45Discretizor_h
#define _C45Discretizor_h 1


#include <RealDiscretizor.h>
#include <C45Inducer.h>

class C45Discretizor : public RealDiscretizor{
   NO_DEFAULT_OPS(C45Discretizor);
   
   // Member data (also see public data)
   C45Inducer ind;

   // Private methods
   void build_thresholds(RealAndLabelColumn*& column, Real trim); 
public:
   // Public data
   static const MString defaultC45Flags;

   // Methods
   C45Discretizor(int attrNum, const SchemaRC& schema);
   C45Discretizor(int attrNum, const SchemaRC& schema, const MString&
		  c45Flags);
   C45Discretizor(const C45Discretizor& disc, CtorDummy);
   virtual void set_log_level(int level) const
     { RealDiscretizor::set_log_level(level); ind.set_log_level(level);}
   virtual Bool operator== (const RealDiscretizor& rhs) const;
   int class_id() const { return CLASSID_C45DISC;}
   RealDiscretizor* clone() const; //returns copy of self
};


PtrArray<RealDiscretizor*>*
create_c45_discretizors(LogOptions& logOptions,
			const InstanceList& instList);

#endif

