// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _ContinFilterInducer_h
#define _ContinFilterInducer_h 1
#include <Array.h>
#include <Inducer.h>
#include <GetOption.h>
#include <BaseInducer.h>
#include <InstanceList.h>
#include <convDisplay.h>


class ContinFilterInducer : public BaseInducer {
   NO_DEFAULT_OPS(ContinFilterInducer);

   // Member data (also see public data)
   BaseInducer *continInducer;
   Normalization normMethod;
   Conversion convMethod;   
public:
   // Public data
   static const Normalization defaultNormMethod;
   static const Conversion defaultConvMethod;

   // Methods
   ContinFilterInducer(const MString& descr);
   ~ContinFilterInducer();
   
   int class_id() const { return CF_INDUCER;}
   Real train_and_test(InstanceList* trainingSet, const InstanceList& testSet);
   void set_cf_sub_inducer(BaseInducer*& ind);
   void set_norm_method(Normalization val) { normMethod = val; }
   Normalization get_norm_method() const { return normMethod; }
   void set_conv_method(Conversion val) { convMethod = val; }
   Conversion get_conv_method() const { return convMethod; }
   void set_user_options(const MString& preFix);
};
#endif


