// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _CN2Inducer_h
#define _CN2Inducer_h 1

#include <BaseInducer.h>
#include <Inducer.h>
#include <MLCStream.h>
#include <LogOptions.h>

class CN2Inducer : public BaseInducer {
private:
   NO_DEFAULT_OPS(CN2Inducer);

   // Member data (also see public data)
   MString pgmName;
   MString redirectString;
public:
   // Public data
   static const MString defaultPgmName;
   static const MString defaultRedirectString;

   // Methods
   CN2Inducer(const MString& description, 
	      const MString& thePgmName = defaultPgmName);

   virtual ~CN2Inducer();
   virtual int class_id() const { return CN2_INDUCER; }
   virtual Real train_and_test(InstanceList* trainingSet,
			       const InstanceList& testList);
   virtual void set_pgm_name(const MString& name) { pgmName = name; }
   virtual MString get_pgm_name() const { return pgmName; }
   virtual void set_redirect_string(const MString& val);
   virtual MString get_redirect_string() const
   { return redirectString; }
   
   virtual void set_user_options(const MString& prefix);
};
#endif





