// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _CascadeCat_h
#define _CascadeCat_h 1

#include <Categorizer.h>
#include <DisplayPref.h>
#include <Array.h>

class CascadeCat : public Categorizer {
   NO_DEFAULT_OPS(CascadeCat);

   // Member data
   PtrArray<Categorizer *> * catList;   
public:
   virtual void OK(int level = 0) const;

   CascadeCat( const MString& dscr,
	       PtrArray<Categorizer *>*& cats,
	       const SchemaRC& schema);
   
   CascadeCat( const CascadeCat& source, const CtorDummy);
   virtual ~CascadeCat();

   virtual const PtrArray<Categorizer *> & get_categorizer_list() const
       {return *catList;}

   virtual AugCategory categorize(const InstanceRC& inst) const;

   virtual void display_struct(MLCOStream& stream,
			       const DisplayPref& dp) const;

   virtual void display(MLCOStream& stream = Mcout,
			const DisplayPref& dp = defaultDisplayPref) const;

   virtual Categorizer* clone() const;

   
   virtual int class_id() const { return CLASS_CASCADE_CATEGORIZER; }

   virtual Bool operator==(const Categorizer& rhs) const;
   virtual int num_categorizers() const { return catList->size(); }
};

DECLARE_DISPLAY(CascadeCat)

#endif





