// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef CENTROID1D_H_
#define CENTROID1D_H_ 1

#include <MString.h>
#include <Centroid.h>
//#include <NominalDistanceFunctor.h>


class PerCentroid1D_ : public PerCentroid_
{
public:
   int attrNum;

   virtual void read(MInStore& in);
   virtual void write(MOutStore& out);
};

class Centroid1D : public Centroid
{
   NO_COPY_CTOR(Centroid1D);
   int attrNum; 

protected:
   virtual PtrArray<Centroid*>* no_initialization( int numCents ) = 0;
   virtual PtrArray<Centroid*>* uniform_initialization( int numCents ) = 0;
   virtual PtrArray<Centroid*>* random_initialization( int numCents ) = 0;

public:
   virtual void OK(int level=0) const;
   Centroid1D(const SchemaRC& schema, int attributeNum);
   Centroid1D(const Centroid1D& other, CtorDummy);
   Centroid1D(const SchemaRC& schema, PerCentroid1D_& helper);
   virtual void fill_helper(PersistentHelper_& helper) const;
   virtual ~Centroid1D() { DBG(OK()); }

   virtual Bool operator==( const Centroid& rhs ) const;
   Bool operator==( const Centroid1D& rhs )const;

   virtual Bool can_cast_to_1D() const { return TRUE; }
   virtual Centroid1D* cast_to_1D() { return this; }

   virtual int attr_num() const { return attrNum; }
   virtual AttrValue_ attr_val() const = 0;
   virtual const AttrInfo& attr_info() const
      { return get_schema().attr_info(attrNum); }
   
   virtual void display(MLCOStream& stream = Mcout) const;
};

DECLARE_DISPLAY(Centroid1D)

#endif
