// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _ClusterOneD_h
#define _ClusterOneD_h 1

#include <LogOptions.h>
#include <Cluster.h>
#include <InstanceList.h>

// Cluster by one dimension given as attrNum.


class Cluster1D : public Cluster {

   // Member data
  int clusterAttrNum;
protected:
   // Protected methods
  virtual Centroid* get_prototype();

public:

  Cluster1D( const MString& description );
  Cluster1D( const Cluster1D& source, CtorDummy);
  virtual Cluster* clone();

  virtual ~Cluster1D() {}

  virtual void OK(int /* level */=0) const;

  InstanceList* release_data();

  virtual int class_id() const { return( CLASS_CLUSTER_1D_ID ); };
  virtual Bool operator==( const Cluster& other ) const;
  virtual Bool operator==( const Cluster1D& other ) const;

  void set_attr_num(int attrNum);

};

#endif
