// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _ClusterMultiD_h
#define _ClusterMultiD_h 1

#include <InstanceList.h>
#include <Cluster.h>
#include <LogOptions.h>

class ClusterMultiD : public Cluster
{

public:
  // Con/De-structors

  ClusterMultiD(const MString& description);
  ClusterMultiD(const ClusterMultiD& source, CtorDummy);
  virtual Cluster* clone();

  virtual ~ClusterMultiD();

  virtual void OK(int /* level */=0) const;
  
  virtual int class_id() const { return( CLASS_CLUSTER_MULTID_ID ); };
  virtual Bool operator==( const Cluster& rhs ) const;
  virtual Bool operator==( const ClusterMultiD& rhs ) const;

  Centroid* get_prototype();
};

#endif
