// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _ConstLeafGenerator_h
#define _ConstLeafGenerator_h 1

#include <LeafGenerator.h>

class ConstCategorizer;

class ConstLeafGenerator : public LeafGenerator {
   NO_DEFAULT_OPS(ConstLeafGenerator);

protected:
   virtual void find_error_info(const ConstCategorizer& constCat,
				SubtreeInfo& info) const;
   virtual void add_debug_info(ConstCategorizer& constCat,
			       const SubtreeInfo& info) const;
   
public:
   ConstLeafGenerator() : LeafGenerator() { }
   virtual ~ConstLeafGenerator() { }

   virtual Bool leaf_appropriate(SubtreeInfo& info) const;
   virtual LeafCategorizer *generate_leaf(SubtreeInfo& info) const;
};

#endif
