// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the ConstrCat and
// functions, see the file name with a "c" suffix.

#ifndef _ConstrCat_h
#define _ConstrCat_h 1

#include <Categorizer.h>

class ConstructOp;

class ConstrCat : public Categorizer {
   NO_DEFAULT_OPS(ConstrCat);

   // Member data
   ConstructOp *constructOp;
   Categorizer *innerCat;
public:
   void OK(int level = 0) const;
   ConstrCat(const MString& dscr, Categorizer*& subCat, ConstructOp*& cOp);
   ConstrCat(const ConstrCat& rhs, CtorDummy);
   ~ConstrCat();

   Categorizer *clone() const { return new ConstrCat(*this, ctorDummy); }
   int class_id() const { return CLASS_CONSTRUCT_CATEGORIZER; }

   virtual Bool operator==(const Categorizer& rhs) const;
   
   virtual AugCategory categorize(const InstanceRC& inst) const;

   const Categorizer& inner_cat() const { DBG(OK()); return *innerCat; }
   void display_struct(MLCOStream& stream, const DisplayPref& dp) const;
};

#endif
