// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _ConstructOp_h
#define _ConstructOp_h 1

#include <InstanceOp.h>
#include <FCExpression.h>

class ConstructOp : public InstanceOp {
   NO_DEFAULT_OPS(ConstructOp);

   // Member data
   FCExpression expression;
public:
   ConstructOp(const SchemaRC& schema, const FCExpression& expr);
   ConstructOp(const ConstructOp& op, CtorDummy);
   InstanceOp *clone() const { return new ConstructOp(*this, ctorDummy); }
   
   const FCExpression& get_expression() const { return expression; }
   
   InstanceRC apply(const InstanceRC& inst) const;
   SchemaRC apply(const SchemaRC& schema) const;
   int class_id() const { return CLASS_CONSTRUCT_OP; }
   void display(MLCOStream& out = Mcout) const;
   virtual Bool operator==(const InstanceOp& rhs) const;
};

DECLARE_DISPLAY(ConstructOp)

#endif
