// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _DTCategorizer_h
#define _DTCategorizer_h 1

#include <RDGCat.h>

// DT is Decision Tree

class DecisionTree;

class PerDTCategorizer_ : public PerRDGCategorizer_ {
};

class DTCategorizer: public RDGCategorizer {
   NO_DEFAULT_OPS(DTCategorizer);

protected:
   // Protected method
   virtual DecisionTree& get_tree() { return (DecisionTree &) (*rcGraph); }

public:
   virtual void OK(int level = 0)const;
   // gets ownership of DecisionTree
   DTCategorizer(DecisionTree*& dt, const MString& dscr, int numCat,
		 const SchemaRC& schema);
   DTCategorizer(const DTCategorizer& source, CtorDummy);
   DTCategorizer(const PerDTCategorizer_& data,
		 const SchemaRC& schema,
		 NodeInfo*& prototype,
		 const Array<NodeInfo *>& nodes);

   virtual ~DTCategorizer();
   virtual Bool supports_backfit() const { return TRUE; }
   virtual void backfit(const InstanceList& instList);
   virtual Categorizer* clone() const;
   // Returns class id
   virtual int class_id() const { return CLASS_DTREE_CATEGORIZER; }
   virtual Bool operator==(const Categorizer& rhs) const;

   virtual Bool supports_persistence() const { return TRUE; }
   virtual PerCategorizer_ *build_persistent_object() const {
      return new PerDTCategorizer_; }
};

#endif
