// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _DiscSearchInducer_h
#define _DiscSearchInducer_h 1

#include <SearchInducer.h>
#include <DiscState.h>

class DiscSearchInducer : public SearchInducer {
   NO_DEFAULT_OPS(DiscSearchInducer);
public:
   enum Direction { forward, middle, backward };

   // Public member data (also see protected data)
   Bool middleRestricted; /* up one down one only */
protected:
   // Protected member data
   Direction direction;

public:
   DiscSearchInducer(const MString& description, BaseInducer* ind = NULL);
   virtual ~DiscSearchInducer();
   virtual int class_id() const { return DISC_SEARCH_INDUCER; }
   
   virtual void set_user_options(const MString& prefix);
   void display(MLCOStream& stream = Mcout) const;

   virtual PerfEstInfo *create_global_info() const
      {return new DiscInfo(); }
   virtual Array<int> *create_initial_info(InstanceList*);
   virtual PerfEstState *create_initial_state(Array<int> *&initialInfo,
					      const PerfEstInfo& gI) const 
      {return new DiscState(initialInfo, gI); }

   virtual Categorizer *state_to_categorizer(const Array<int>& stateInfo)
      const;
         
};

DECLARE_DISPLAY(DiscSearchInducer)

#endif

