// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _DribbleEngine_h
#define _DribbleEngine_h 1

class DribbleEngine {
   NO_DEFAULT_OPS(DribbleEngine);

   MLCOStream& dribbleStream;
   Real resolution;
   Real lastOutput;
   
   Real progress;
   Bool finished;

protected:
   void reset();
   void update_output();
   
public:
   DribbleEngine(MLCOStream& stream);
   virtual ~DribbleEngine() { }

   virtual void set_dribble_resolution(Real res);
   virtual Real get_dribble_resolution() const { return resolution; }

   virtual void set_dribble_message(const MString& dribbleMessage);
   virtual void add_dribble_proportion(Real dribbleProportion);
   virtual void set_dribble_completion(Real amountFinished);
   virtual void section_finished();
};

extern DribbleEngine *globalDribble;  // defined in basicCore.c

#endif
