// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _EntropyODGInducer_h
#define _EntropyODGInducer_h 1

#include <DTCategorizer.h>
#include <InstanceList.h>
#include <ODGInducer.h>
#include <Array.h>
#include <DynamicArray.h>
#include <SplitAttr.h>


class EntropyODGInducer : public ODGInducer {
   NO_DEFAULT_OPS(EntropyODGInducer);

   // Member data
   DynamicArray<int> *orderVector;
   
   // Private methods
   BoolArray* setup_order_vec();
public: 
   EntropyODGInducer(const MString& dscr, CGraph* aCgraph = NULL) :
      ODGInducer(dscr, aCgraph) {orderVector=NULL;}
   ~EntropyODGInducer();

   virtual int class_id() const { return ENTROPY_ODG_INDUCER; }
   Real average_conflict_ratio(DynamicArray<const InstanceList*> &instLists);
   virtual NodeCategorizer *best_split(Array<UsedAttributes>& usedAttributes,
				       DynamicArray<SplitAttr>& splits,
				       DynamicArray<const InstanceList*> &,
				       Array<MString>*& catNames,
				       Real& minCondEntropy,
				       Real previousEntropy);
   const Array<int>& get_order_vector();
   int best_depth();
   virtual void train();
};

#endif
