// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _ConstrFilterInducer_h
#define _ConstrFilterInducer_h 1

#include <Inducer.h>
#include <FeatureSearch.h>
#include <ConstrCat.h>

class ConstrCat;

class ConstrFilterInducer : public Inducer {
   NO_DEFAULT_OPS(ConstrFilterInducer);

   // Member data
   FeatureSearch searcher;
   Categorizer *categorizer;
   Inducer *inducer;   
public:
   ConstrFilterInducer(const MString& descr);
   ConstrFilterInducer(const ConstrFilterInducer& rhs, CtorDummy);
   ~ConstrFilterInducer();
   Inducer *copy() const { return new ConstrFilterInducer(*this, ctorDummy); }
   void train();
   Bool was_trained(Bool fatalOnFalse = TRUE) const;
   const Categorizer& get_categorizer() const;
   virtual Categorizer* release_categorizer()
   { Categorizer* fcc = categorizer; categorizer = NULL; return fcc; }

   int class_id() const { return FCF_INDUCER;}
   Real train_and_test(InstanceList* trainingSet,
		       const InstanceList& testSet); 

   void display_struct(MLCOStream& stream = Mcout,
		       const DisplayPref& dp = defaultDisplayPref) const;

   Bool can_cast_to_inducer() const { return TRUE; }
   void set_user_options(const MString& prefix);
   void set_user_options_no_inducer(const MString& prefix);
   void assign_inducer(Inducer*& inducer);
   Inducer* release_inducer();
};

#endif
