// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _FSSInducer_h
#define _FSSInducer_h 1

#include <SearchInducer.h>
#include <FSSState.h>
#include <ProjectInd.h>

class FSSInducer : public SearchInducer {
   NO_DEFAULT_OPS(FSSInducer);
public:
   enum Direction { forward, backward };

protected:
   // Protected member data
   Direction direction;

public:   
   FSSInducer(const MString& description, BaseInducer* ind = NULL);
   virtual int class_id() const { return FSS_INDUCER; }
   
   virtual void set_user_options(const MString& prefix);
   virtual void display(MLCOStream& stream = Mcout) const;
   virtual PerfEstInfo *create_global_info() const
      {return new FSSInfo(); }
   virtual Array<int> *create_initial_info(InstanceList*);
   virtual PerfEstState *create_initial_state(Array<int> *&initialInfo,
					      const PerfEstInfo& gI) const
      {return new FSSState(initialInfo, gI); }
   virtual Categorizer *state_to_categorizer(const Array<int>& stateInfo)
      const;
         
};

DECLARE_DISPLAY(FSSInducer)

#endif
