// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _FSSState_h
#define _FSSState_h 1

#include <DynamicArray.h>
#include <CompState.h>
#include <InstanceList.h>
#include <BaseInducer.h>


class FSSInfo : public PerfEstInfo {
   // Default Ctor is used by FSSInducer
   NO_OPERATOR_ASSIGN(FSSInfo);
public:
   virtual int lower_bound(int) { return 0; }
   virtual int upper_bound(int) { return 1; }
   virtual void display_values(const Array<int>& values, MLCOStream& out =
			       Mcout) const;
   virtual int class_id() const { return FSS_INFO; }
};


class FSSState : public CompState {
   NO_DEFAULT_OPS(FSSState);
public:
   FSSState(Array<int>*& featureSubset, const PerfEstInfo& gI);
   virtual ~FSSState() { }

   virtual CompState *create_state(Array<int>*& info)
      {return new FSSState(info, globalInfo);}

   // functions for deriving from PerfEstState
   virtual void construct_lists(PerfEstInfo *, InstanceList *&,
			        InstanceList *& /*testList*/);
   virtual void destruct_lists(PerfEstInfo *, InstanceList *,
			       InstanceList * /*testList*/);

   // display functions
   virtual void display_info(MLCOStream& stream) const;
};


#endif





