// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _ID3Inducer_h
#define _ID3Inducer_h 1

#include <TDDTInducer.h>
#include <SplitAttr.h>

class ID3Inducer : public TDDTInducer {
   NO_DEFAULT_OPS(ID3Inducer);
public:
   ID3Inducer(const MString& dscr, CGraph* aCgraph = NULL) :
      TDDTInducer(dscr, aCgraph) {}
   ID3Inducer(const ID3Inducer& source, CtorDummy) :
      TDDTInducer(source, ctorDummy) {}
   virtual ~ID3Inducer() {}
   virtual NodeCategorizer* best_split(Array<MStringRC>*& catNames) const;
   virtual Bool multi_val_attribute(int attrNum) const;
   virtual Bool all_attributes_multi_val() const;
   virtual Bool find_splits(SplitAttr*& bestSplit,
			    Array<SplitAttr>& splits) const;
   virtual void best_split_info(SplitAttr*& bestSplit,
				Array<SplitAttr>& splits) const;
   virtual void pick_best_split(SplitAttr*& bestSplit,
				Array<SplitAttr>& splits,
				StatData &allMutualInfo,
				StatData &allNonMultiValMutualInfo) const;

   virtual TDDTInducer* create_subinducer(const MString& dscr,
					  CGraph& aCgraph) const;
   void split_info(int attrNum, SplitAttr& split,
		   PtrArray<RealAndLabelColumn*>* realColumns = NULL) const;
   virtual NodeCategorizer* split_to_cat(SplitAttr& split,
					 Array<MStringRC>*& catNames) const;
   virtual Inducer* copy() const;
   virtual int class_id() const { return ID3_INDUCER; }
};
#endif
