// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef InstListAndDistance_h
#define InstListAndDistance_h 1
#include <InstanceList.h>

class InstListAndDistance {
private:
   // Member data
   InstanceList* instList;
   Real distance;
public:
   InstListAndDistance() { instList = NULL; distance = REAL_MAX; }
   virtual ~InstListAndDistance() { delete instList; }
   InstListAndDistance& operator=(const InstListAndDistance& elem);
   InstListAndDistance(const InstanceRC& instance, Real dist);
   Real get_distance() const;
   void set_distance(Real dist);
   void insert(const InstanceRC& instance, Real dist);
   const InstanceList& get_inst_list() const;
   // The following comparison operators return ints, so they should be
   //   used for sorting.  Also, there's no need for an operator!=.
   int operator<(const InstListAndDistance& element) const;
   int operator>(const InstListAndDistance& element) const;
   int operator==(const InstListAndDistance& element) const;
   void display(MLCOStream& stream = Mcout, Bool normalizeReal = FALSE) const;
};

DECLARE_DISPLAY(InstListAndDistance)
#endif
