// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _InstListMinArray_h
#define _InstListMinArray_h 1
#include <InstanceList.h>
#include <MinArray.h>
#include <InstListAndDistance.h>
#include <IBInducer.h>

class InstListMinArray : protected MinArray<InstListAndDistance> {
   NO_COPY_CTOR(InstListMinArray);
public:
   void OK(int /* level = 0 */) const;
   InstListMinArray(int k) : MinArray<InstListAndDistance>(k){}
   void insert(const InstanceRC& inst, Real distance); 
   int num_elem() const { return MinArray<InstListAndDistance>::num_elem(); }
   const InstListAndDistance& operator[](int i) const {
      return MinArray<InstListAndDistance>::operator[](i);
   }
   InstListAndDistance& operator[](int i) {
      return MinArray<InstListAndDistance>::operator[](i);
   }
   
   const InstListAndDistance& max() const
      {return MinArray<InstListAndDistance>::max(); }
   const InstListAndDistance& max(int& idx) const
          { return MinArray<InstListAndDistance>::max(idx); }
   Category major_category(const IBInducer::NeighborVote vote,
				 const IBInducer::NnkValue nnk) const;
   void display(MLCOStream& stream = Mcout, Bool normalizeReal = FALSE) const; 
};

DECLARE_DISPLAY(InstListMinArray)
#endif

