// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _IntArrayAndCount_h
#define _IntArrayAndCount_h 1

#include <IntArray.h>

class IntArrayAndCount : public IntArray {
public:
   Real count;

   // a copy constructor must be included; this is the datatype of a
   // UniversalHashTable.
   IntArrayAndCount(const IntArrayAndCount& source)
      : IntArray(source, ctorDummy), count(source.count) { }
   IntArrayAndCount(int size, StoredReal startCount = 0.0)
      : IntArray(size), count(startCount) { }
   virtual ~IntArrayAndCount() { }
   
   virtual void display(MLCOStream& stream = Mcout) const;
   virtual Bool contains_key(const IntArray& otherKey) const {
      return (*this == otherKey);
   }
   virtual const IntArray& get_key() const { return *this; }
   virtual IntArrayAndCount& operator=(const IntArrayAndCount& rhs);
};

Bool operator==(const IntArrayAndCount& lhs, const IntArrayAndCount& rhs);
Bool operator!=(const IntArrayAndCount& lhs, const IntArrayAndCount& rhs);

DECLARE_DISPLAY(IntArrayAndCount)

#endif
