/*******************************************************************************
+
+  LEDA 3.5
+
+
+  bool.h
+
+
+  Copyright (c) 1995, 1996, 1997  by  LEDA Software GmbH
+  Postfach 151101, 66041 Saarbruecken, Germany
+  All rights reserved.
+ 
*******************************************************************************/


#ifndef LEDA_BOOL_H
#define LEDA_BOOL_H

#if !defined(LEDA_ROOT_INCL_ID)
#define LEDA_ROOT_INCL_ID 350020
#include <LEDA/REDEFINE_NAMES.h>
#endif

#if !defined(__HAS_BUILTIN_BOOL__)


/*{\Manpage {bool} {} {Boolean Values} }*/

/*{\Mdefinition
An instance of the data type $bool$ has either the value $true$ or $false$. 
The usual \CC logical operators \&\& (and), $||$ (or), ! (negation) are 
defined for $bool$. }*/

#if defined(_MSC_VER)
#pragma warning(disable: 4237)
#endif

typedef char bool;
enum {false=0, true=1};

#endif


#if LEDA_ROOT_INCL_ID == 350020
#undef LEDA_ROOT_INCL_ID
#include <LEDA/UNDEFINE_NAMES.h>
#endif

#endif
