/*******************************************************************************
+
+  LEDA 3.5
+
+
+  d3_window.h
+
+
+  Copyright (c) 1995, 1996, 1997  by  LEDA Software GmbH
+  Postfach 151101, 66041 Saarbruecken, Germany
+  All rights reserved.
+ 
*******************************************************************************/


#include <LEDA/graph.h>
#include <LEDA/vector.h>
#include <LEDA/d3_rat_point.h>
#include <LEDA/d3_point.h>
#include <LEDA/window.h>


class __exportC poly_anim {

typedef GRAPH<d3_rat_point,int> polyeder;
typedef GRAPH<d3_point,int> f_polyeder;

bool   grey_scales;
bool   draw_solid;
bool   elim;
bool   draw_edges;
bool   draw_graph;
double speed;
double total_rot1;
double total_rot2;
double rot1;
double rot2;
double zoom_f;
node_array<vector> pos1;


window*      Wp;
const graph* Hp;

public:

poly_anim(window& W, const polyeder& P);
poly_anim(window& W, const f_polyeder& P);

void init(window& W, const polyeder& P);
void init(window& W, const f_polyeder& P);

void draw();
void draw_poly();
int  move();
void zoom(double);

void set_speed(int s)  { speed = s; }
void set_elim(bool b)  { elim  = b; }
void set_solid(bool b) { draw_solid = b; }
void set_draw_edges(bool b) { draw_edges = b; }
void set_draw_graph(bool b) { draw_graph = b; }
void set_position(node v, d3_point p) ;

};

