// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _LeafGenerator_h
#define _LeafGenerator_h 1

#include <DDTInducer.h>

class LeafCategorizer;
class SubtreeInfo;

class LeafGenerator { // ABC
   NO_DEFAULT_OPS(LeafGenerator);
   LOG_OPTIONS;

   DDTInducer::LeafDistType distributionType;
   Real distributionParameter;

public:
   LeafGenerator();
   virtual ~LeafGenerator() { }

   virtual Bool leaf_appropriate(SubtreeInfo& info) const = 0;
   virtual LeafCategorizer *generate_leaf(SubtreeInfo& info) const = 0;

   DDTInducer::LeafDistType get_leaf_dist_type() const
   { return distributionType; }
   void set_leaf_dist_type(DDTInducer::LeafDistType ldType)
   { distributionType = ldType; }

   Real get_leaf_dist_parameter() const { return distributionParameter; }
   void set_leaf_dist_parameter(Real parameter);
};


#endif
