// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file "NullInducer.c".

#ifndef _NullInducer_h
#define _NullInducer_h 1

#include <Inducer.h>

class NullInducer : public Inducer {
   NO_DEFAULT_OPS(NullInducer);

   // Member data
   Bool abortOnCalls;
   Bool trained;      // was train() called
public:
   NullInducer(const MString& description, Bool fatalOnCalls = TRUE);

   virtual int class_id() const { return NULL_INDUCER; }

   InstanceList* assign_data(InstanceList*& newTS);
   virtual void read_data(const MString& file,
			  const MString& namesExtension = DEFAULT_NAMES_EXT,
			  const MString& dataExtension = DEFAULT_DATA_EXT);
   virtual InstanceList* release_data();
   virtual Bool has_data(Bool fatalOnFalse = TRUE) const;
   const InstanceList& instance_list() const;
   virtual void train();
   virtual Bool was_trained(Bool fatalOnFalse = TRUE) const;
   virtual const Categorizer& get_categorizer() const;
   virtual Categorizer *release_categorizer();
   virtual void display_struct(MLCOStream& stream = Mcout,
			       const DisplayPref& dp = defaultDisplayPref)
      const;
};

#endif


