// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the "OneRCategorizer.c".

#ifndef _OneRCategorizer_h
#define _OneRCategorizer_h 1

#include <TableCat.h>
#include <RealDiscretizor.h>

class OneRCategorizer : public TableCategorizer {
private:
   NO_DEFAULT_OPS(OneRCategorizer);

   // Member data
   BoolArray attrMask;
   const int attrNumber;
   const SchemaRC projectedSchema;
   const SchemaRC originalSchema;
   RealDiscretizor* realDiscretizor;
public:
   OneRCategorizer(int attrNum,
		   const SchemaRC& orgSchema,
		   RealDiscretizor*& realDisc,
		   const TableCategorizer* tableCat);
   OneRCategorizer(const OneRCategorizer& source, CtorDummy ctorDummy);
   virtual ~OneRCategorizer();
   virtual AugCategory categorize(const InstanceRC&) const;
   virtual void display_struct(MLCOStream& stream,
			       const DisplayPref& dp) const; 
   virtual int class_id() const { return CLASS_ONE_R_CATEGORIZER; }
   virtual Bool operator== (const Categorizer& rhs) const;
   virtual Categorizer* clone() const;
};
#endif
