// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _OneRInducer_h
#define _OneRInducer_h 1

#include <OneR.h>
#include <TableInducer.h>
#include <OneRCategorizer.h>

class OneRInducer : public Inducer {
private:
   NO_DEFAULT_OPS(OneRInducer);

   // Member data
   int minInstPerLabel;
   OneRCategorizer* categorizer;   
public:
   OneRInducer(const MString& description, int small);
   virtual ~OneRInducer();
   virtual void train();
   virtual Bool was_trained(Bool fatalOnFalse = TRUE) const;
   virtual const Categorizer& get_categorizer() const; 
   virtual Categorizer* release_categorizer();
   virtual int class_id() const { return ONER_INDUCER; };
};


#endif

