// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _OrderFSSInd_h
#define _OrderFSSInd_h 1

#include <SearchInducer.h>
#include <OrderFSSState.h>
#include <AttrOrder.h>

class OrderFSSInducer : public SearchInducer {
   NO_DEFAULT_OPS(OrderFSSInducer);
public:
   enum Direction { forward, backward };
   enum InnerType { listHOODG, COODG, tableCas, listODG, ODT };
private:
   // Member data
   Inducer *innerInducer; // @@ remove. Searchinducer has it
   Direction direction;
   AttrOrder ao;
public:
   static Inducer* search_inducer();
   OrderFSSInducer(const MString& description, Inducer* ind = NULL);
   virtual int class_id() const { return ORDER_FSS_INDUCER; }
   
   virtual void set_user_options(const MString& prefix);
   
   virtual PerfEstInfo *create_global_info() const
      {return new OrderInfo; }
   virtual Array<int> *create_initial_info(InstanceList* trainingSet);
   virtual PerfEstState *create_initial_state(Array<int> *&initialInfo,
					      const PerfEstInfo& gI) const
      { return new OrderFSSState(initialInfo, gI); }
   virtual Categorizer *state_to_categorizer(const Array<int>& stateInfo)
      const;
};


#endif
