// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _PerfEstInducer_h
#define _PerfEstInducer_h 1

#include <BaseInducer.h>
#include <PerfEstDispatch.h>
#include <MRandom.h>

class PerfEstInducer : public BaseInducer {
   RAND_OPTIONS;

protected:
   // Protected member data
   PerfEstDispatch perfEst;
   BaseInducer *baseInducer;
   Bool ownBaseInducer;
   
public:
   PerfEstInducer(const MString& prefix,
		 const MString& description, BaseInducer* ind = NULL);
   virtual ~PerfEstInducer();
   virtual int class_id() const { return PERF_EST_INDUCER; }
   
   Real train_and_test_files(const MString& fileStem,
			     const MString& namesExtension = DEFAULT_NAMES_EXT,
			     const MString& dataExtension = DEFAULT_DATA_EXT,
			     const MString& testExtension = DEFAULT_TEST_EXT);
   void init(const MString& prefix); // get options from user
   void display(MLCOStream& stream = Mcout) const;
   virtual Real train_and_test(InstanceList* trainingSet,
			       const InstanceList& testList);
};

DECLARE_DISPLAY(PerfEstInducer)

#endif
