// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _PersistentCat_h
#define _PersistentCat_h 1

#include <Persistence.h>
#include <Categorizer.h>


// helper functions for reading and writing persistent categorizers.
Categorizer *read_sub_categorizer(MInStore& in, const SchemaRC& schema);
void write_sub_categorizer(MOutStore& out, const Categorizer& cat);

// simple functions to read and write persistent categorizers.  Note that
// not all types of categorizers are supported.
Categorizer *read_categorizer(const MString& filename);
void write_categorizer(const Categorizer& cat, const MString& filename);
SchemaRC read_categorizer_schema(const MString& filename,
				 int& catID);

#endif
