// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _PersistentDisc_h
#define _PersistentDisc_h 1

#include <InstanceList.h>
#include <Attribute.h>
#include <Persistence.h>
#include <RealDiscretizor.h>

// All discretizors read from disk files become "persistent discretizors".
class PersistentDiscretizor : public RealDiscretizor {
   NO_DEFAULT_OPS(PersistentDiscretizor);

protected:
   // Protected method
   virtual void build_thresholds(RealAndLabelColumn*&, Real) { }

public:
   PersistentDiscretizor(const PerRealDiscretizor_& data)
      : RealDiscretizor(data) { }
   PersistentDiscretizor(const PersistentDiscretizor& disc, CtorDummy)
      : RealDiscretizor(disc, ctorDummy)
      {}
   virtual RealDiscretizor* clone() const {
      return new PersistentDiscretizor(*this, ctorDummy); }
   virtual Bool operator==(const RealDiscretizor &other) const {
      return RealDiscretizor::operator==(other); }
   int class_id() const {
      return CLASSID_PERSISTDISC; }
};

RealDiscretizor *read_persistent_discretizor(MInStore& in);
void write_persistent_discretizor(const RealDiscretizor& disc,
				  MOutStore& out);

#endif

