// MLC++ - Machine Learning in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file. For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _PtrUniversalHashTable_h
#define _PtrUniversalHashTable_h 1

#include <PtrHashTable.h>
#include <RandCharArray.h>

// This class implements hash table based on Universal hash function.

template <class KeyType, class DataType>
class PtrUniversalHashTable :  public PtrHashTable<KeyType, DataType> {

   // can't use NO_COPY_CTOR2() because compiler get confused with
   // two template arguments of HashTable.
   PtrUniversalHashTable(const PtrUniversalHashTable& );
   
protected :
   RandCharArray randomData;   
   virtual int hash(const KeyType& keyValue) const;

public :
   PtrUniversalHashTable(int estimatedNumElement);
   PtrUniversalHashTable(int estimatedNumElement, unsigned int seed);
   PtrUniversalHashTable(const PtrUniversalHashTable& source, CtorDummy);
   virtual ~PtrUniversalHashTable() {}
};

#ifdef COMPILE_TIME_TEMPLATES
#include "PtrUnivHash.ct"
#endif

#endif

    


