// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _RealSplitter_h
#define _RealSplitter_h 1

#include <Splitter.h>
#include <SplitAttr.h>

class RealSplitter : public Splitter {
   Bool applyMDLPenalty;
public:
   RealSplitter(SplitScore::SplitScoreCriterion criterion)
      : Splitter(criterion), applyMDLPenalty(FALSE) { }
   virtual ~RealSplitter() { }

   Bool get_apply_mdl_penalty() const { return applyMDLPenalty; }
   void set_apply_mdl_penalty(Bool b) { applyMDLPenalty = b; }
   
   DblLinkList<SplitSuggestion*> *
   suggest_splits(SubtreeInfo& info, int attrNum) const;
};

#endif
