// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _SANode_h
#define _SANode_h 1

#include <CGraph.h>
#include <AugCategory.h>

class SANode {
   NO_COPY_CTOR(SANode);
public:
   // Public member data
   NodePtr Node; // Hello!!! 'node' shadows a typedef!!! sigh...
   int numEvaluations;
   Bool isExpanded;
   Real fitness;

   // Methods
   SANode();
   SANode(NodePtr nodePtr, Real initFitness);
   SANode& operator=(const SANode& rhs);
   virtual ~SANode() {}

   Bool operator<(const SANode& rhs) const;
   Bool operator==(const SANode& rhs) const;
   Bool operator!=(const SANode& rhs) const
      {return ! ((*this)== rhs);}
};


#endif
