// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file "SmartInstCtr.c"


#ifndef _SmartInstCounter_h
#define _SmartInstCounter_h 1

#include <IntArray.h>
#include <InstCounts.h>
#include <PtrUnivHash.h>

class InstanceList;
class MString;

class SmartInstCounter
   : private PtrUniversalHashTable<IntArray, InstCounts>  {

   NO_COPY_CTOR(SmartInstCounter);
   const InstanceList& instances;

   DBG_DECLARE(int numHits;)
   DBG_DECLARE(int numMisses;)
public:
   virtual void OK(int level = 2) const;
   SmartInstCounter(const InstanceList& il);
   SmartInstCounter(const SmartInstCounter& source, CtorDummy);
   virtual ~SmartInstCounter();

   const InstanceList& get_instances() const { return instances; }      

   const InstCounts& counters(const IntArray& attrs);

   DBG_DECLARE(virtual void stats(const MString& description);)
};

#endif
