// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _SplitSuggestion_h
#define _SplitSuggestion_h 1

#include <SchemaRC.h>

class NodeCategorizer;

class SplitSuggestion { // ABC
   Real mutualInfo;  // for gain ratio, we need both score and mutualInfo.
   Real score;
   int attrNum;
   MString description;

public:
   SplitSuggestion(Real mi, Real aScore, const MString& dscr, int attr)
      : mutualInfo(mi), score(aScore), attrNum(attr), description(dscr) { }
   virtual ~SplitSuggestion() { }

   Real get_mutual_info() const { return mutualInfo; }
   Real get_score() const { return score; }
   int get_attr() const { return attrNum; }
   const MString& get_description() const { return description; }
   
   virtual NodeCategorizer *build_categorizer(const SchemaRC& schema)
      const = 0;

   virtual void display(MLCOStream& stream) const;
};

DECLARE_DISPLAY(SplitSuggestion)

#endif
