// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _Splitter_h
#define _Splitter_h 1

#include <DblLinkList.h>
#include <SplitScore.h>

class AttributeColumn;
class SplitSuggestion;
class SplitAttr;
class SubtreeInfo;

class Splitter { // ABC
   const SplitScore::SplitScoreCriterion splitCriterion;

protected:
   void add_debug_string(const SubtreeInfo& info, const SplitAttr& splitAttr,
			 MString& baseName) const;

public:
   Splitter(SplitScore::SplitScoreCriterion criterion)
      : splitCriterion(criterion) { }
   virtual ~Splitter() { }

   // Splitters are allowed to return NULL, but if they do return a list, all
   // of its elements must be non-NULL.
   virtual DblLinkList<SplitSuggestion*> *
   suggest_splits(SubtreeInfo& info, int attrNum) const = 0;

   SplitScore::SplitScoreCriterion get_split_criterion() const
   { return splitCriterion; }
};

#endif
