// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _StackingCat_h
#define _StackingCat_h 1

#include <Categorizer.h>

class InstanceRC;
class MLCOStream;
class DisplayPref;

class StackingCat : public Categorizer {
   NO_DEFAULT_OPS(StackingCat);

   // Member data
   PtrArray<Categorizer*> *catArray;
   Categorizer *stackedCat;
   int numCats;
   Bool stackWithInst;

   // Private method
   InstanceRC create_meta_instance(const InstanceRC& instance,
				   const Array<Category>& categories) const;
public:
   virtual void OK(int level = 0) const;

   StackingCat(int noCat, const MString& dscr, const SchemaRC& sch,
	       PtrArray<Categorizer*>*& cats, Categorizer*& stackCat);
   StackingCat(const StackingCat& source, CtorDummy);
   virtual ~StackingCat();

   virtual AugCategory categorize(const InstanceRC&) const;
   virtual void display_struct(MLCOStream& stream,
			       const DisplayPref& dp) const;
   virtual Categorizer* clone(void) const;

   virtual int class_id(void) const { return CLASS_STACKING_CATEGORIZER; }

   virtual Bool operator==(const Categorizer& rhs) const;

   void set_stack_with_inst(Bool stackInst) { stackWithInst = stackInst; }
};

#endif
