// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _T2Discretizor_h
#define _T2Discretizor_h 1

#include <RealDiscretizor.h>

class T2Discretizor : public RealDiscretizor{
   NO_DEFAULT_OPS(T2Discretizor);
   
   // Member data
   int numBins;

   // Private methods
   void run_t2(const InstanceList& instList, int numIntervals);
   void build_thresholds(RealAndLabelColumn*& column, Real trim);
public:
   T2Discretizor(int attrNum, const SchemaRC& schema, int numIntervals);
   T2Discretizor(const T2Discretizor& disc, CtorDummy);
   virtual Bool operator== (const RealDiscretizor& rhs) const;
   int class_id() const { return CLASSID_T2DISC;}
   RealDiscretizor* clone() const; //returns copy of self
};

PtrArray<RealDiscretizor*>*
create_t2_discretizors(LogOptions& logOptions,
		       const InstanceList& InstList,
		       const Array<int>& columnBinCount,
		       const Array<Real>& columnTrim);

PtrArray<RealDiscretizor*>*
create_t2_discretizors(LogOptions& logOptions,
		       const InstanceList& instList,
		       int binCount,
		       Real trim = 0);

#endif

