// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _UniformRangeDiscretizor_h
#define _UniformRangeDiscretizor_h 1

#include <RealDiscretizor.h>

class UniformRangeDiscretizor : public RealDiscretizor{
   NO_DEFAULT_OPS(UniformRangeDiscretizor);

   // Member data
   int  numBins;
protected:
   // Protected method
   void build_thresholds(RealAndLabelColumn*& column, Real trim);
public:
   UniformRangeDiscretizor(int attrNum,
			 const SchemaRC& schema,
			 int nBins);
   UniformRangeDiscretizor(const UniformRangeDiscretizor&, CtorDummy);
   virtual Bool operator==(const RealDiscretizor& rhs) const;
   int class_id() const{ return CLASSID_EQUALWIDTHDISC;}
   RealDiscretizor* clone() const;
};

PtrArray<RealDiscretizor*>*
create_uniform_range_discretizors(LogOptions& logOptions,
				  const InstanceList& instList,
				  const Array<int>& columnBinCount,
				  const Array<Real>& columnTrim);

PtrArray<RealDiscretizor*>*
create_uniform_range_discretizors(LogOptions& logOptions,
				  const InstanceList& instList,
				  int binCount,
				  Real trim = 0);
#endif
