// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _UniformWeightDiscretizor_h
#define _UniformWeightDiscretizor_h 1

#include <RealDiscretizor.h>

class UniformWeightDiscretizor : public RealDiscretizor{
   NO_DEFAULT_OPS(UniformWeightDiscretizor);

   // Member data
   int  numBins;
protected:
   // Protected method
   void build_thresholds(RealAndLabelColumn*& column, Real trim);
public:
   UniformWeightDiscretizor(int attrNum,
			  const SchemaRC& schema,
			  int nBins);
   UniformWeightDiscretizor(const UniformWeightDiscretizor&, CtorDummy);
   virtual Bool operator==(const RealDiscretizor& rhs) const;
   int class_id() const{ return CLASSID_EQUALWEIGHTDISC;}
   RealDiscretizor* clone() const;
};

PtrArray<RealDiscretizor*>*
create_uniform_weight_discretizors(LogOptions& logOptions,
				   const InstanceList& instList,
				   const Array<int>& columnBinCount,
				   const Array<Real>& columnTrim);

PtrArray<RealDiscretizor*>*
create_uniform_weight_discretizors(LogOptions& logOptions,
				   const InstanceList& instList,
				   int binCount,
				   Real trim = 0);
#endif
