// MLC++ - Machine Learning in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file. For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _UniversalHashTable_h
#define _UniversalHashTable_h 1

#include <HashTable.h>
#include <RandCharArray.h>

// This class implements hash table based on Universal hash function.

template <class KeyType, class DataType>
class UniversalHashTable :  public HashTable<KeyType, DataType> {
   NO_COPY_CTOR(UniversalHashTable);
   NO_OPERATOR_ASSIGN(UniversalHashTable);

protected :
   RandCharArray randomData;   
   virtual int hash(const KeyType& keyValue) const;

public :
   UniversalHashTable(int estimatedNumElement);
   UniversalHashTable(int estimatedNumElement, unsigned int seed);
   UniversalHashTable(const UniversalHashTable& source, CtorDummy);
   virtual ~UniversalHashTable() {}
};

#ifdef COMPILE_TIME_TEMPLATES
#include "UnivHashTable.ct"
#endif

#endif

    


