// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _ValuePartition_h_
#define _ValuePartition_h_ 1

#include <Array.h>
#include <Attribute.h>    // needed for NominalVal

class ValuePartition : public PtrArray<Array<NominalVal>*> {
   NO_DEFAULT_OPS(ValuePartition);

   // Member data
   const NominalAttrInfo& attrInfo;
public:
   ValuePartition(int size, const NominalAttrInfo& info)
      : PtrArray<Array<NominalVal>*>(size), attrInfo(info) { }
   ValuePartition(const ValuePartition& source, CtorDummy);
   ~ValuePartition() { }

   const NominalAttrInfo& get_attr_info() const { return attrInfo; }
   void display(MLCOStream& stream) const;

   #ifdef PC_MSVC_AMBIG
   Bool operator==(const ValuePartition& rhs) const;
   Bool operator!=(const ValuePartition& rhs) const;
   #endif
};

#ifndef PC_MSVC_AMBIG
Bool operator==(const ValuePartition& lhs, const ValuePartition& rhs);
Bool operator!=(const ValuePartition& lhs, const ValuePartition& rhs);
#endif

DECLARE_DISPLAY(ValuePartition)

#endif
