// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _WeightSearchInducer_h
#define _WeightSearchInducer_h 1

#include <SearchInducer.h>
#include <WeightState.h>

class WeightSearchInducer : public SearchInducer {
   NO_DEFAULT_OPS(WeightSearchInducer);

   // Member data
   Bool startWithFSS;
public:
   WeightSearchInducer(const MString& description, BaseInducer* ind = NULL);
   virtual ~WeightSearchInducer();
   virtual int class_id() const { return WEIGHT_SEARCH_INDUCER; }
   
   virtual void set_user_options(const MString& prefix);
   void display(MLCOStream& stream = Mcout) const;

   virtual PerfEstInfo *create_global_info() const {
      return new WeightInfo(); }
   virtual Array<int> *create_initial_info(InstanceList*);
   virtual PerfEstState *create_initial_state(Array<int> *&initialInfo,
					     const PerfEstInfo& gI) const
      { return new WeightState(initialInfo, gI); }

   virtual Categorizer *state_to_categorizer(const Array<int>& stateInfo)
      const;
};

DECLARE_DISPLAY(WeightSearchInducer)

#endif
