// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _mlcio_h
#define _mlcio_h 1

void parse_error(MLCIStream& input, const MString& errorMsg);
Bool legal_attr_char(MLCIStream&, char& c,
		     Bool periodAllowed=FALSE);
Bool skip_white_comments_same_line(MLCIStream& file);
MStringRC read_word (MLCIStream&, Bool qMark, Bool& sameLine,
		     Bool periodAllowed = FALSE);
MStringRC read_word_on_same_line(MLCIStream&, Bool qMark,
		     Bool periodAllowed = FALSE);		      
MString read_section(MLCIStream& in, const MString& delims,
		     const MString& ignoreChars = EMPTY_STRING,
		     Bool allowEOF = FALSE);
MString read_section_ws(MLCIStream& in, const MString& delims,
			const MString& wsChars, Bool allowEOF = FALSE);
MString read_section_str(const MString& in, int& pos,
			 const MString& delims,
			 const MString& ignoreChars,
			 Bool allowNULL = FALSE);
void report_str_error(const MString& in, int pos,
		      const MString& errPrefix,
		      const MString& errSuffix,
		      Bool isFatal = TRUE);
void remove_file(const MString& file, Bool convertToNative = TRUE);
void remove_wildcard_files(const MString& fileString,
			   Bool convertToNative = TRUE);

// directory management
void remove_directory(const MString& directory, Bool convertToNative = TRUE);
MString get_current_directory();
void change_directory(const MString& dir);
void make_directory(const MString& name, int mode);

MString full_path(const MString& str, Bool fatalOnFalse = FALSE);
Bool file_exists(const MString& str, Bool fatalOnFalse = FALSE);
void truncate_file(MLCOStream& stream);
void skip_blank_space(MLCIStream& file);
#endif
