// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#ifndef _search_enums_h
#define _search_enums_h 1

#include <MEnum.h>

// this file defines enumerated types used throughout the search
// mechanism.  These enums are declared globally because they relate
// to the templated classes SearchDispatch and the SSSearch
// heirarchy.  Declaring enums within templated classes causes problems
// because template arguments must always be specified when referring
// to the enum!

enum SearchMethod { bestFirst, hillClimbing, simulatedAnnealing };

enum ShowTestSetPerf { showNever, showFinalOnly, showBestOnly,
		       showAlways };

// external definitions for option-related variables
extern const MEnum searchMethodEnum;
extern const MEnum showTestSetPerfEnum;

extern const SearchMethod DEFAULT_SEARCH_METHOD;
extern const MString SEARCH_METHOD_HELP;
extern const ShowTestSetPerf DEFAULT_SHOW_TEST_SET_PERF;
extern const MString SHOW_TEST_SET_PERF_HELP;

extern const int DEFAULT_EVAL_LIMIT;
extern const MString EVAL_LIMIT_HELP;
extern const int DEFAULT_MAX_STALE;
extern const MString MAX_STALE_HELP;
extern const Real DEFAULT_EPSILON;
extern const MString EPSILON_HELP;
extern const int DEFAULT_MAX_EVALS;
extern const MString MAX_EVALS_HELP;

extern const int DEFAULT_MIN_EXP_EVALS;
extern const MString MIN_EXP_EVALS_HELP;
extern const Real DEFAULT_LAMBDA;
extern const MString LAMBDA_HELP;
extern const int DEFAULT_SAS_SEED;
extern const MString SAS_SEED_HELP;


#endif


