// MLC++ - Machine Learning Library in -*- C++ -*-
// See Descrip.txt for terms and conditions relating to use and distribution.

// This is an include file.  For a full description of the class and
// functions, see the file name with a "c" suffix.

#include <InstanceList.h>
#include <MEnum.h>

#ifndef _upload_to_db_h
#define _upload_to_db_h 1


extern const MEnum dbmsEnum;

struct LegalChars {
   NO_DEFAULT_OPS(LegalChars);

   // Public member data
   Bool alpha;
   Bool numeric;
   DynamicArray <char> special;

   // Methods
   LegalChars()
      : alpha(FALSE), numeric(FALSE)
      {special.truncate(0);}
};

class DatabaseInfo {
   NO_DEFAULT_OPS(DatabaseInfo);
public:
   enum DBMSType {informix = 0, oracle = 1, sybase = 2};

   // Public member data
   DBMSType dataBaseID;
   int maxStringLength;
   Bool caseSensitive;
   LegalChars firstChars;
   LegalChars chars; // All characters after the first.
   MString realLabel;
   MString stringLabel;
   MString varStringLabel;
   MString createCommand;
   MString createWithNull;
   MString creationSeparator;
   MString fileExtension;
   MString userName;
   MString passWord;
   DynamicArray<MString> *reservedWords;

   // Methods
   DatabaseInfo(const MString& reservedWordFile);
   ~DatabaseInfo();

   void set_db_info();
};


int upload_to_db(const InstanceList& instList,
		 const MString& rootName,
		 const DatabaseInfo& dbInfo);

#endif
